<?php
// If this file is called directly, abort.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

$whitelist_elems = array(
	"a",
	"altGlyph",
	"altGlyphDef",
	"altGlyphItem",
	"animate",
	"animateColor",
	"animateMotion",
	"animateTransform",
	"circle",
	"clipPath",
	"color-profile",
	"cursor",
	"defs",
	"desc",
	"ellipse",
	"feBlend",
	"feColorMatrix",
	"feComponentTransfer",
	"feComposite",
	"feConvolveMatrix",
	"feDiffuseLighting",
	"feDisplacementMap",
	"feDistantLight",
	"feFlood",
	"feFuncA",
	"feFuncB",
	"feFuncG",
	"feFuncR",
	"feGaussianBlur",
	"feImage",
	"feMerge",
	"feMergeNode",
	"feMorphology",
	"feOffset",
	"fePointLight",
	"feSpecularLighting",
	"feSpotLight",
	"feTile",
	"feTurbulence",
	"filter",
	"font",
	"font-face",
	"font-face-format",
	"font-face-name",
	"font-face-src",
	"font-face-uri",
	"foreignObject",
	"g",
	"glyph",
	"glyphRef",
	"hkern",
	"image",
	"line",
	"linearGradient",
	"marker",
	"mask",
	"metadata",
	"missing-glyph",
	"mpath",
	"path",
	"pattern",
	"polygon",
	"polyline",
	"radialGradient",
	"rect",
	"set",
	"stop",
	"style",
	"svg",
	"switch",
	"symbol",
	"text",
	"textPath",
	"title",
	"tref",
	"tspan",
	"use",
	"view",
	"vkern"
	);

$whitelist_attrs = array(
	"data-borderless-svg","data-borderless-svg-custom","data-borderless-svg-morph","data-global-borderless-svg",
	"svgns","adobens","metans","inkns","msns",
	"accent-height",
	"accumulate",
	"additive",
	"alphabetic",
	"amplitude",
	"arabic-form",
	"ascent",
	"attributeName",
	"attributeType",
	"azimuth",
	"baseFrequency",
	"baseProfile",
	"bbox",
	"begin",
	"bias",
	"by",
	"calcMode",
	"cap-height",
	"class",
	"clipPathUnits",
	"contentStyleType",
	"cx",
	"cy",
	"d",
	"descent",
	"diffuseConstant",
	"divisor",
	"dur",
	"dx",
	"dy",
	"edgeMode",
	"elevation",
	"end",
	"exponent",
	"externalResourcesRequired",
	"fill",
	"filterRes",
	"filterUnits",
	"font-family",
	"font-size",
	"font-stretch",
	"font-style",
	"font-variant",
	"font-weight",
	"format",
	"from",
	"fx",
	"fy",
	"g1",
	"g2",
	"glyph-name",
	"glyphRef",
	"gradientTransform",
	"gradientUnits",
	"hanging",
	"height",
	"horiz-adv-x",
	"horiz-origin-x",
	"href",
	"id",
	"ideographic",
	"in",
	"in2",
	"in2",
	"in2",
	"intercept",
	"k",
	"k1",
	"k2",
	"k3",
	"k4",
	"kernelMatrix",
	"kernelUnitLength",
	"keyPoints",
	"keySplines",
	"keyTimes",
	"lang",
	"lengthAdjust",
	"limitingConeAngle",
	"local",
	"markerHeight",
	"markerUnits",
	"markerWidth",
	"maskContentUnits",
	"maskUnits",
	"mathematical",
	"max",
	"media",
	"method",
	"min",
	"mode",
	"name",
	"numOctaves",
	"offset",
	"operator",
	"order",
	"orient",
	"orientation",
	"origin",
	"overline-position",
	"overline-thickness",
	"panose-1",
	"path",
	"pathLength",
	"patternContentUnits",
	"patternTransform",
	"patternUnits",
	"points",
	"pointsAtX",
	"pointsAtY",
	"pointsAtZ",
	"preserveAlpha",
	"preserveAspectRatio",
	"primitiveUnits",
	"r",
	"radius",
	"refX",
	"refY",
	"rendering-intent",
	"repeatCount",
	"repeatDur",
	"requiredExtensions",
	"requiredFeatures",
	"restart",
	"result",
	"rotate",
	"rx",
	"ry",
	"scale",
	"seed",
	"slope",
	"spacing",
	"specularConstant",
	"specularExponent",
	"spreadMethod",
	"startOffset",
	"stdDeviation",
	"stemh",
	"stemv",
	"stitchTiles",
	"strikethrough-position",
	"strikethrough-thickness",
	"string",
	"style",
	"surfaceScale",
	"systemLanguage",
	"tableValues",
	"target",
	"targetX",
	"targetY",
	"textLength",
	"title",
	"to",
	"transform",
	"type",
	"u1",
	"u2",
	"underline-position",
	"underline-thickness",
	"unicode",
	"unicode-range",
	"units-per-em",
	"v-alphabetic",
	"v-hanging",
	"v-ideographic",
	"v-mathematical",
	"values",
	"version",
	"vert-adv-y",
	"vert-origin-x",
	"vert-origin-y",
	"viewBox",
	"viewTarget",
	"width",
	"widths",
	"x",
	"x-height",
	"x1",
	"x2",
	"xChannelSelector",
	"xlink:actuate",
	"xlink:arcrole",
	"xlink:href",
	"xlink:role",
	"xlink:show",
	"xlink:title",
	"xlink:type",
	"xml:base",
	"xml:lang",
	"xml:space",
	"y",
	"y1",
	"y2",
	"yChannelSelector",
	"z",
	"zoomAndPan",
	"alignment-baseline",
	"baseline-shift",
	"clip-path",
	"clip-rule",
	"clip",
	"color-interpolation-filters",
	"color-interpolation",
	"color-profile",
	"color-rendering",
	"color",
	"cursor",
	"direction",
	"display",
	"dominant-baseline",
	"enable-background",
	"fill-opacity",
	"fill-rule",
	"fill",
	"filter",
	"flood-color",
	"flood-opacity",
	"font-family",
	"font-size-adjust",
	"font-size",
	"font-stretch",
	"font-style",
	"font-variant",
	"font-weight",
	"glyph-orientation-horizontal",
	"glyph-orientation-vertical",
	"image-rendering",
	"kerning",
	"letter-spacing",
	"lighting-color",
	"marker-end",
	"marker-mid",
	"marker-start",
	"mask",
	"opacity",
	"overflow",
	"pointer-events",
	"shape-rendering",
	"stop-color",
	"stop-opacity",
	"stroke-dasharray",
	"stroke-dashoffset",
	"stroke-linecap",
	"stroke-linejoin",
	"stroke-miterlimit",
	"stroke-opacity",
	"stroke-width",
	"stroke",
	"text-anchor",
	"text-decoration",
	"text-rendering",
	"unicode-bidi",
	"visibility",
	"word-spacing",
	"writing-mode"
	);
